//Copyright (C) 2000 Microsoft Corporation.  All rights reserved.

//This source code is intended only as a supplement to Microsoft
//Development Tools and/or on-line documentation.  See these other
//materials for detailed information regarding Microsoft code samples.

//THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
//KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
//IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
//PARTICULAR PURPOSE.

namespace [!output SAFE_NAMESPACE_NAME]
{
using System;
using System.Drawing;
using System.Drawing.Printing;

using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;


/// <summary>
///    Summary description for Form1.
/// </summary>
public class Form1 : System.Windows.Forms.Form
{
	/// <summary> 
	///    Required designer variable
	/// </summary>
	/// 

	private System.ComponentModel.IContainer components;
	private System.Windows.Forms.StatusBar statusBar1;
	private System.Windows.Forms.ImageList imageList1;
	private System.Windows.Forms.ToolBarButton printButton;
	private System.Windows.Forms.ToolBarButton previewButton;
	private System.Windows.Forms.ToolBarButton saveButton;
	private System.Windows.Forms.ToolBarButton openButton;
	private System.Windows.Forms.ToolBarButton newButton;
	private System.Windows.Forms.ToolBar toolBar1;
	private System.Drawing.Printing.PrintDocument printDoc;
		
	private System.Windows.Forms.MenuItem menuItemAbout;
	private System.Windows.Forms.MenuItem menuItemStatusbar;
	private System.Windows.Forms.MenuItem menuItemToolbar;
	private System.Windows.Forms.MenuItem menuItemExit;
	private System.Windows.Forms.MenuItem menuItem16;
	private System.Windows.Forms.MenuItem menuItemPreview;
	private System.Windows.Forms.MenuItem menuItemPrint;
	private System.Windows.Forms.MenuItem menuItem12;
	private System.Windows.Forms.MenuItem menuItemSaveAs;
	private System.Windows.Forms.MenuItem menuItemSave;
	private System.Windows.Forms.MenuItem menuItemOpen;
	private System.Windows.Forms.MenuItem menuItemNew;
	private System.Windows.Forms.MenuItem menuItemHelp;
	private System.Windows.Forms.MenuItem menuItemView;
	private System.Windows.Forms.MenuItem menuItemFile;
	private System.Windows.Forms.MainMenu mainMenu1;
	private SDIDoc _newdoc;

	public static String fileExtension = ".doc";

	/// <summary>
	///   Constructor
	/// </summary>
	public Form1()
	{        
		//
		// Required for Win Form Designer support
		//
		InitializeComponent();	
		
		CreateDocument();

	 }

	/// <summary>
	///    Clean up any resources being used
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	/// <summary>
	///    Required method for Designer support - do not modify
	///    the contents of this method with the code editor
	/// </summary>
	private void InitializeComponent()
	{
		this.components = new System.ComponentModel.Container();
		System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
		this.openButton = new System.Windows.Forms.ToolBarButton();
		this.printDoc = new System.Drawing.Printing.PrintDocument();
		this.menuItemOpen = new System.Windows.Forms.MenuItem();
		this.menuItemView = new System.Windows.Forms.MenuItem();
		this.menuItemToolbar = new System.Windows.Forms.MenuItem();
		this.menuItemStatusbar = new System.Windows.Forms.MenuItem();
		this.saveButton = new System.Windows.Forms.ToolBarButton();
		this.menuItemHelp = new System.Windows.Forms.MenuItem();
		this.menuItemAbout = new System.Windows.Forms.MenuItem();
		this.menuItemNew = new System.Windows.Forms.MenuItem();
		this.menuItemFile = new System.Windows.Forms.MenuItem();
		this.menuItemSave = new System.Windows.Forms.MenuItem();
		this.menuItemSaveAs = new System.Windows.Forms.MenuItem();
		this.menuItem12 = new System.Windows.Forms.MenuItem();
		this.menuItemPrint = new System.Windows.Forms.MenuItem();
		this.menuItemPreview = new System.Windows.Forms.MenuItem();
		this.menuItemExit = new System.Windows.Forms.MenuItem();
		this.menuItem16 = new System.Windows.Forms.MenuItem();
		this.printButton = new System.Windows.Forms.ToolBarButton();
		this.toolBar1 = new System.Windows.Forms.ToolBar();
		this.newButton = new System.Windows.Forms.ToolBarButton();
		this.previewButton = new System.Windows.Forms.ToolBarButton();
		this.imageList1 = new System.Windows.Forms.ImageList(this.components);
		this.mainMenu1 = new System.Windows.Forms.MainMenu();
		this.statusBar1 = new System.Windows.Forms.StatusBar();
		this.SuspendLayout();
		// 
		// openButton
		// 
		this.openButton.ImageIndex = 1;
		this.openButton.ToolTipText = "Open";
		// 
		// printDoc
		// 
		this.printDoc.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.SDIPrintPage);
		// 
		// menuItemOpen
		// 
		this.menuItemOpen.Index = 1;
		this.menuItemOpen.Text = "Open...";
		this.menuItemOpen.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemView
		// 
		this.menuItemView.Index = 1;
		this.menuItemView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemToolbar,
																					 this.menuItemStatusbar});
		this.menuItemView.Text = "View";
		// 
		// menuItemToolbar
		// 
		this.menuItemToolbar.Checked = true;
		this.menuItemToolbar.Index = 0;
		this.menuItemToolbar.Text = "Toolbar";
		this.menuItemToolbar.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemStatusbar
		// 
		this.menuItemStatusbar.Checked = true;
		this.menuItemStatusbar.Index = 1;
		this.menuItemStatusbar.Text = "Status Bar";
		this.menuItemStatusbar.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// saveButton
		// 
		this.saveButton.ImageIndex = 2;
		this.saveButton.ToolTipText = "Save";
		// 
		// menuItemHelp
		// 
		this.menuItemHelp.Index = 2;
		this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemAbout});
		this.menuItemHelp.Text = "Help";
		// 
		// menuItemAbout
		// 
		this.menuItemAbout.Index = 0;
		this.menuItemAbout.Text = "About SDI Application";
		this.menuItemAbout.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemNew
		// 
		this.menuItemNew.Index = 0;
		this.menuItemNew.Text = "New";
		this.menuItemNew.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemFile
		// 
		this.menuItemFile.Index = 0;
		this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemNew,
																					 this.menuItemOpen,
																					 this.menuItemSave,
																					 this.menuItemSaveAs,
																					 this.menuItem12,
																					 this.menuItemPrint,
																					 this.menuItemPreview,
																					 this.menuItemExit});
		this.menuItemFile.Text = "File";
		// 
		// menuItemSave
		// 
		this.menuItemSave.Index = 2;
		this.menuItemSave.Text = "Save";
		this.menuItemSave.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemSaveAs
		// 
		this.menuItemSaveAs.Index = 3;
		this.menuItemSaveAs.Text = "Save As...";
		this.menuItemSaveAs.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItem12
		// 
		this.menuItem12.Index = 4;
		this.menuItem12.Text = "-";
		// 
		// menuItemPrint
		// 
		this.menuItemPrint.Index = 5;
		this.menuItemPrint.Text = "Print...";
		this.menuItemPrint.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemPreview
		// 
		this.menuItemPreview.Index = 6;
		this.menuItemPreview.Text = "Print Preview";
		this.menuItemPreview.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItemExit
		// 
		this.menuItemExit.Index = 7;
		this.menuItemExit.Text = "Exit";
		this.menuItemExit.Click += new System.EventHandler(this.MenuItemHandler);
		// 
		// menuItem16
		// 
		this.menuItem16.Index = -1;
		this.menuItem16.Text = "-";
		// 
		// printButton
		// 
		this.printButton.ImageIndex = 4;
		this.printButton.ToolTipText = "Print";
		// 
		// toolBar1
		// 
		this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					this.newButton,
																					this.openButton,
																					this.saveButton,
																					this.previewButton,
																					this.printButton});
		this.toolBar1.DropDownArrows = true;
		this.toolBar1.ImageList = this.imageList1;
		this.toolBar1.Location = new System.Drawing.Point(0, 0);
		this.toolBar1.Name = "toolBar1";
		this.toolBar1.ShowToolTips = true;
		this.toolBar1.Size = new System.Drawing.Size(588, 28);
		this.toolBar1.TabIndex = 1;
		this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
		// 
		// newButton
		// 
		this.newButton.ImageIndex = 0;
		this.newButton.ToolTipText = "New";
		// 
		// previewButton
		// 
		this.previewButton.ImageIndex = 3;
		this.previewButton.ToolTipText = "Print Preview";
		// 
		// imageList1
		// 
		this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
		this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
		this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
		// 
		// mainMenu1
		// 
		this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				  this.menuItemFile,
																				  this.menuItemView,
																				  this.menuItemHelp});
		// 
		// statusBar1
		// 
		this.statusBar1.Font = new System.Drawing.Font("Arial", 8F);
		this.statusBar1.Location = new System.Drawing.Point(0, 384);
		this.statusBar1.Name = "statusBar1";
		this.statusBar1.Size = new System.Drawing.Size(588, 16);
		this.statusBar1.TabIndex = 2;
		this.statusBar1.Text = "For Help,  press F1";
		// 
		// Form1
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.BackColor = System.Drawing.Color.White;
		this.ClientSize = new System.Drawing.Size(588, 400);
		this.Controls.Add(this.toolBar1);
		this.Controls.Add(this.statusBar1);
		this.Menu = this.mainMenu1;
		this.Name = "Form1";
		this.Text = "SDI sample Application";
		this.Closing += new System.ComponentModel.CancelEventHandler(this.ClosingMainAppHandler);
		this.Paint += new System.Windows.Forms.PaintEventHandler(this.PaintHandler);
		this.ResumeLayout(false);

	}

	//Handle the Menu Item clicks
	private void MenuItemHandler(object sender, System.EventArgs e)
	{
		if(sender == menuItemNew)	
		{
			New();
		}
		else if(sender == menuItemOpen)
		{
			Open();
		}
		else if(sender == menuItemSave)
		{
			Save();
		}
		else if(sender == menuItemPreview)
		{
			PrintPreview();
		}
		else if(sender == menuItemPrint)
		{
			Print();
		}
		else if(sender == menuItemAbout)
		{
			AboutHelp();
		}
		else if(sender == menuItemExit)
		{
			Exit();
		}
		else if(sender == menuItemSaveAs)
		{
			Save();
		}
		else if(sender == menuItemToolbar)
		{
			toolBar1.Visible  = menuItemToolbar.Checked  = !toolBar1.Visible ;
		}
		else if(sender == menuItemStatusbar)
		{
			statusBar1.Visible = menuItemStatusbar.Checked = !statusBar1.Visible;			
		}
	}

	//Handle the Toolbar button clicks
	 private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
	{
		if(e.Button == newButton)	
		{
			New();
		}
		else if(e.Button==openButton)
		{
			Open();
		}
		else if(e.Button==saveButton)
		{
			Save();
		}
		else if(e.Button == previewButton)
		{
			PrintPreview();
		}
		else if(e.Button == printButton)
		{
			Print();
		}
	}

	//About Help
	private void AboutHelp()
	{
		MessageBox.Show("SDI App Version 1.0\nBuilt From MS Scribble sample", "About SDIApp");
	}

	
	//Print
	private void Print()
	{
		try 
		{			
			printDoc.Print();
		} 
		catch(Exception e)
		{
			MessageBox.Show(e.ToString());
		}
        
	}

	//PrintPage event handler
	private void SDIPrintPage(object sender,PrintPageEventArgs ev)
	{
		try{
			SDIView activeView = (SDIView) _newdoc.viewList[0];
			activeView.PrintPage(sender, ev);
		}
		catch (Exception ex)
		{
			MessageBox.Show(ex.ToString());
		}
	}


	private void PaintHandler(object sender, System.Windows.Forms.PaintEventArgs e)
	{
		SDIView activeView = (SDIView) _newdoc.viewList[0];
		activeView.PaintHandler(sender, e);
	}


	//PrintPreview
	private void PrintPreview()
	{
		try
		{		
			PrintPreviewDialog prevDlg = new PrintPreviewDialog();
			prevDlg.Document = printDoc;
			prevDlg.Size = new System.Drawing.Size(600, 329);
			prevDlg.ShowDialog();
		}
		catch(Exception ex)
		{
			MessageBox.Show(ex.ToString());
		}
		
	}

	//Exit
	private void Exit()
	{
		Application.Exit();
	}

	//Open an existing document
	private void Open()
	{
		OpenFileDialog openDlg = new OpenFileDialog();
		openDlg.Filter  = "SDI Files (*" + fileExtension + ")|*" + fileExtension + "|All Files (*.*)|*.*";
		openDlg.FileName = "" ;
		openDlg.DefaultExt = fileExtension;
		openDlg.CheckFileExists = true;
		openDlg.CheckPathExists = true;
		
		DialogResult res = openDlg.ShowDialog ();
		
		if(res == DialogResult.OK)
		{
			if( !(openDlg.FileName).EndsWith(fileExtension) && 
				!(openDlg.FileName).EndsWith(fileExtension.ToUpper())) 
				MessageBox.Show("Unexpected file format","SDI App",MessageBoxButtons.OK );
			else
			{
				Clear();
				CreateDocument();
				_newdoc.OpenDocument(openDlg.FileName);
			}
		}		
		
	}

	//Save the document
	private void Save()
	{
		SDIView selectedView = (SDIView) _newdoc.viewList[0];
		SaveFileDialog saveDlg = new SaveFileDialog();
		saveDlg.Filter = "SDI Files (*"+ fileExtension +")|*"+ fileExtension + "|All Files (*.*)|*.*";
		saveDlg.DefaultExt = fileExtension;
		DialogResult res = saveDlg.ShowDialog ();
		
		if(res == DialogResult.OK)
			selectedView.GetDocument().SaveDocument(saveDlg.FileName);		

	}

	private void Clear()
	{
		if(_newdoc.isDirty && _newdoc.viewList.Count == 1)
		{
			DialogResult save = MessageBox.Show("Do you want to Save changes ?","SDIApp",MessageBoxButtons.YesNoCancel);
			if (save == DialogResult.Yes)
				Save();
		}

		if (_newdoc.viewList.Count == 1)
		{
			_newdoc.RemoveView();
		}
	}

	//Open new document
	private void New()
	{	
		Clear();
		CreateDocument();						
	}
    
	//Creates a new document
	private SDIDoc CreateDocument()
	{
		_newdoc = new SDIDoc (this);
		return _newdoc;
	}


	//App closing handler
	public void ClosingMainAppHandler(Object sender,CancelEventArgs e)
	{
		Clear();
		this.Exit();		
	}

	/*
	* The main entry point for the application.
    *
    */
	[STAThread]
	public static void Main(string[] args) 
	{
	Application.Run(new Form1());
	}

}
}
